|
@@ -4630,6 +4630,7 @@ Add the following in the section which begins with *<VirtualHost *:443>*.
|
4630
|
4630
|
#+BEGIN_SRC: bash
|
4631
|
4631
|
ProxyVia On
|
4632
|
4632
|
ProxyPreserveHost On
|
|
4633
|
+ ProxyRequests Off
|
4633
|
4634
|
SSLProxyEngine On
|
4634
|
4635
|
|
4635
|
4636
|
ProxyPass / https://localhost:7270/
|
|
@@ -7034,6 +7035,213 @@ monkeysphere-host import-key /etc/ssh/ssh_host_rsa_key ssh://$HOSTNAME
|
7034
|
7035
|
monkeysphere-host publish-key
|
7035
|
7036
|
#+END_SRC
|
7036
|
7037
|
|
|
7038
|
+** Diaspora
|
|
7039
|
+
|
|
7040
|
+First install some dependencies:
|
|
7041
|
+
|
|
7042
|
+#+BEGIN_SRC: bash
|
|
7043
|
+aptitude install build-essential libssl-dev libcurl4-openssl-dev libxml2-dev libxslt-dev imagemagick git-core redis-server curl libmysqlclient-dev libmagickwand-dev librtmp-dev libgnutls-dev libp11-kit-dev libp11-kit0 curl
|
|
7044
|
+#+END_SRC
|
|
7045
|
+
|
|
7046
|
+If there is trouble with dependencies select 'n' then 'y' to the solution.
|
|
7047
|
+
|
|
7048
|
+Create a diaspora user.
|
|
7049
|
+
|
|
7050
|
+#+BEGIN_SRC: bash
|
|
7051
|
+adduser --disabled-login diaspora
|
|
7052
|
+su diaspora
|
|
7053
|
+cd ~/
|
|
7054
|
+curl -L dspr.tk/1t | bash
|
|
7055
|
+echo "[[ -s \"$HOME/.rvm/scripts/rvm\" ]] && source \"$HOME/.rvm/scripts/rvm\"" >> ~/.bashrc
|
|
7056
|
+. ~/.bashrc
|
|
7057
|
+rvm autolibs read-only
|
|
7058
|
+rvm install 2.0.0-p353
|
|
7059
|
+git clone -b master git://github.com/diaspora/diaspora.git
|
|
7060
|
+cd diaspora
|
|
7061
|
+#+END_SRC
|
|
7062
|
+
|
|
7063
|
+Select 'y' to trust /home/diaspora/diaspora/.rvmrc
|
|
7064
|
+
|
|
7065
|
+#+BEGIN_SRC: bash
|
|
7066
|
+cp config/database.yml.example config/database.yml
|
|
7067
|
+cp config/diaspora.yml.example config/diaspora.yml
|
|
7068
|
+editor config/diaspora.yml
|
|
7069
|
+#+END_SRC
|
|
7070
|
+
|
|
7071
|
+Set *url* to https://mydiasporadomainname.com/
|
|
7072
|
+
|
|
7073
|
+Set *certificate_authorities* to */etc/ssl/certs/ca-certificates.crt*
|
|
7074
|
+
|
|
7075
|
+Set *require_ssl* to *true*
|
|
7076
|
+
|
|
7077
|
+Set *single_process_mode* to *false*
|
|
7078
|
+
|
|
7079
|
+Set *port* to 3000
|
|
7080
|
+
|
|
7081
|
+Set *rails_environment* to 'production'.
|
|
7082
|
+
|
|
7083
|
+Set *pod_name* to the name of your pod.
|
|
7084
|
+
|
|
7085
|
+Set *enable_registrations* to *true*.
|
|
7086
|
+
|
|
7087
|
+Set *autofollow_on_join* to *false*
|
|
7088
|
+
|
|
7089
|
+Under *captcha* set *enable* to *false*
|
|
7090
|
+
|
|
7091
|
+Under *invitations* set *open* to *true*
|
|
7092
|
+
|
|
7093
|
+Set *bitcoin_address* if you wish to accept donations.
|
|
7094
|
+
|
|
7095
|
+Under *mail* set *enable* to *true*
|
|
7096
|
+
|
|
7097
|
+Set *sender_address* to no-reply@mydiasporadomainname.com
|
|
7098
|
+
|
|
7099
|
+Set *method* to *sendmail*
|
|
7100
|
+
|
|
7101
|
+Set *exim_fix* to true.
|
|
7102
|
+
|
|
7103
|
+Under *admins* set *account* to *podmaster*
|
|
7104
|
+
|
|
7105
|
+Under *admins* set *podmin_email* to podmin@mydiasporadomainname.com
|
|
7106
|
+
|
|
7107
|
+Save and exit.
|
|
7108
|
+
|
|
7109
|
+#+BEGIN_SRC: bash
|
|
7110
|
+export HOSTNAME=mydiasporadomainname.com
|
|
7111
|
+editor /etc/apache2/sites-available/$HOSTNAME
|
|
7112
|
+#+END_SRC
|
|
7113
|
+
|
|
7114
|
+The initial section which begins with *<VirtualHost *:80>* should be replaced by the following, replacing /mydiasporadomainname.com/ with your Diaspora domain name and /myusername@mydomainname.com/ with your email address.
|
|
7115
|
+
|
|
7116
|
+#+BEGIN_SRC: bash
|
|
7117
|
+<VirtualHost *:80>
|
|
7118
|
+ ServerAdmin myusername@mydomainname.com
|
|
7119
|
+ ServerName mydiasporadomainname.com
|
|
7120
|
+
|
|
7121
|
+ RewriteEngine On
|
|
7122
|
+ RewriteCond %{HTTPS} off
|
|
7123
|
+ RewriteRule (.*) https://%{HTTP_HOST}%{REQUEST_URI}
|
|
7124
|
+</VirtualHost>
|
|
7125
|
+#+END_SRC
|
|
7126
|
+
|
|
7127
|
+Add the following in the section which begins with *<VirtualHost *:443>*.
|
|
7128
|
+
|
|
7129
|
+#+BEGIN_SRC: bash
|
|
7130
|
+ ProxyVia On
|
|
7131
|
+ ProxyPreserveHost On
|
|
7132
|
+ ProxyRequests Off
|
|
7133
|
+ SSLProxyEngine On
|
|
7134
|
+
|
|
7135
|
+ ProxyPass / https://localhost:3000/
|
|
7136
|
+ ProxyPassReverse / https://localhost:3000/
|
|
7137
|
+#+END_SRC
|
|
7138
|
+
|
|
7139
|
+Save and exit.
|
|
7140
|
+
|
|
7141
|
+#+BEGIN_SRC: bash
|
|
7142
|
+RAILS_ENV=production bundle install --without test development
|
|
7143
|
+#+END_SRC
|
|
7144
|
+
|
|
7145
|
+This will take quite a while to install.
|
|
7146
|
+
|
|
7147
|
+#+BEGIN_SRC: bash
|
|
7148
|
+RAILS_ENV=production bundle exec rake db:create db:schema:load
|
|
7149
|
+bundle exec rake assets:precompile
|
|
7150
|
+#+END_SRC
|
|
7151
|
+
|
|
7152
|
+Create an init script:
|
|
7153
|
+
|
|
7154
|
+#+BEGIN_SRC: bash
|
|
7155
|
+editor /etc/init.d/diaspora
|
|
7156
|
+#+END_SRC
|
|
7157
|
+
|
|
7158
|
+Add the following.
|
|
7159
|
+
|
|
7160
|
+#+BEGIN_SRC: bash
|
|
7161
|
+#!/bin/bash
|
|
7162
|
+# /etc/init.d/diaspora
|
|
7163
|
+
|
|
7164
|
+### BEGIN INIT INFO
|
|
7165
|
+# Provides: diaspora
|
|
7166
|
+# Required-Start: $remote_fs $syslog
|
|
7167
|
+# Required-Stop: $remote_fs $syslog
|
|
7168
|
+# Default-Start: 2 3 4 5
|
|
7169
|
+# Default-Stop: 0 1 6
|
|
7170
|
+# Short-Description: starts diaspora
|
|
7171
|
+# Description: Starts Diaspora.
|
|
7172
|
+### END INIT INFO
|
|
7173
|
+
|
|
7174
|
+# Author: Bob Mottram <bob@robotics.uk.to>
|
|
7175
|
+
|
|
7176
|
+#Settings
|
|
7177
|
+SERVICE='diaspora'
|
|
7178
|
+USERNAME='diaspora'
|
|
7179
|
+DIASPORA_HOME=/home/$USERNAME/diaspora
|
|
7180
|
+LOGFILE=/home/$USERNAME/diaspora.log
|
|
7181
|
+COMMAND="cd $DIASPORA_HOME; ./script/server >> $LOGFILE"
|
|
7182
|
+PATH='/usr/local/sbin:/usr/local/bin:/usr/bin:/usr/bin/core_perl:/sbin:/usr/sbin:/bin'
|
|
7183
|
+
|
|
7184
|
+
|
|
7185
|
+diaspora_start() {
|
|
7186
|
+ echo -n $"Starting $SERVICE service: "
|
|
7187
|
+# cd $DIASPORA_HOME
|
|
7188
|
+ su -l $USERNAME -c "$COMMAND"
|
|
7189
|
+ RETVAL=$?
|
|
7190
|
+ echo
|
|
7191
|
+}
|
|
7192
|
+
|
|
7193
|
+
|
|
7194
|
+diaspora_stop() {
|
|
7195
|
+ echo -n $"Stopping $SERVICE service: "
|
|
7196
|
+ # Uncomment here to allow stop
|
|
7197
|
+ su -l $USERNAME -c "$DIASPORA_HOME/script/server"
|
|
7198
|
+ RETVAL=$?
|
|
7199
|
+ echo
|
|
7200
|
+}
|
|
7201
|
+
|
|
7202
|
+
|
|
7203
|
+#Start-Stop here
|
|
7204
|
+case "$1" in
|
|
7205
|
+ start)
|
|
7206
|
+ diaspora_start
|
|
7207
|
+ ;;
|
|
7208
|
+ stop)
|
|
7209
|
+ diaspora_stop
|
|
7210
|
+ ;;
|
|
7211
|
+ restart)
|
|
7212
|
+ diaspora_stop
|
|
7213
|
+ diaspora_start
|
|
7214
|
+ ;;
|
|
7215
|
+ *)
|
|
7216
|
+ echo "Usage: $0 {start|stop|restart}"
|
|
7217
|
+ exit 1
|
|
7218
|
+ ;;
|
|
7219
|
+esac
|
|
7220
|
+
|
|
7221
|
+exit 0
|
|
7222
|
+#+END_SRC
|
|
7223
|
+
|
|
7224
|
+Save and exit.
|
|
7225
|
+
|
|
7226
|
+#+BEGIN_SRC: bash
|
|
7227
|
+chmod +x /etc/init.d/diaspora
|
|
7228
|
+update-rc.d diaspora defaults
|
|
7229
|
+service diaspora start
|
|
7230
|
+#+END_SRC
|
|
7231
|
+
|
|
7232
|
+Now enable the site:
|
|
7233
|
+
|
|
7234
|
+#+BEGIN_SRC: bash
|
|
7235
|
+a2enmod ssl
|
|
7236
|
+a2enmod rewrite
|
|
7237
|
+a2enmod headers
|
|
7238
|
+a2enmod proxy
|
|
7239
|
+a2enmod proxy_connect
|
|
7240
|
+a2enmod proxy_http
|
|
7241
|
+a2ensite $HOSTNAME
|
|
7242
|
+service apache2 restart
|
|
7243
|
+#+END_SRC
|
|
7244
|
+
|
7037
|
7245
|
* Related projects
|
7038
|
7246
|
|
7039
|
7247
|
* [[https://freedomboxfoundation.org/][Freedombox]]
|